#ifndef QR_HH
#define QR_HH

namespace QR {

  typedef double   valueType ; // the type for real number
  typedef unsigned indexType ; // the type for integer (unsigned)

  indexType
  factorize( indexType const n,      /* Number of rows of matrix A             */
             indexType const m,      /* Number of columns of matrix A          */
             valueType       A[],    /* Pointer to coefficients of A           */
             indexType const lda,    /* Leading dimension of A, Fortran style  */
             indexType       ipiv[], /* Permutation vector                     */
             valueType       work[] ) ;

  void
  solve( indexType const n,      /* Number of rows and columns of matrix A */
         valueType const QR[],   /* Pointer to coefficients of LU          */
         indexType const lda,    /* Leading dimension of QR, Fortran style */
         indexType const ipiv[], /* Permutation vector                     */
         valueType const work[],
         valueType       b[],    /* Pointer to coefficients of vector b    */
         indexType       incB ) ;

  void
  applyReflections( indexType const n,      /* Number of rows of matrix QR             */
                    indexType const m,      /* Number of columns of matrix QR          */
                    valueType const QR[],   /* Pointer to coefficients of QR           */
                    indexType const lda,    /* Leading dimension of QR, Fortran style  */
                    indexType const ipiv[], /* Permutation vector                      */
                    valueType const work[],
                    valueType       v[],
                    indexType       incV ) ;

}

#endif