#include "QR.hh"
#include "alglin.hh"
#include <iostream>

using QR::valueType ;
using QR::indexType ;

using namespace std ;

int
main() {

  indexType ipiv[4] ;
  valueType work[4], b[4] ;

  valueType A[4*4] = {
    4, 1, 1, 1,
    1, 4, 1, 1,
    1, 1, 4, 1,
    1, 1, 1, 4  
  } ;

  valueType B[4*4] ;
  valueType x[4] = { 1, 2, 3, 4 } ;

  std::copy( A, A + 16, B ) ;

  alglin::gemv( "No Transpose", 4, 4, 1.0, A, 4, x, 1, 0.0,  b, 1 ) ;

  indexType info = QR::factorize( 4, 4, A, 4, ipiv, work ) ;

  cout << "info = " << info << '\n' ;
  
  cout << "ipiv[0] = " << ipiv[0] << '\n' ;
  cout << "ipiv[1] = " << ipiv[1] << '\n' ;
  cout << "ipiv[2] = " << ipiv[2] << '\n' ;
  cout << "ipiv[3] = " << ipiv[3] << '\n' ;

  QR::applyReflections( 4, 4, A, 4, ipiv, work, B, 1 );
  cout << "B[0] = " << B[0] << '\n';
  cout << "B[1] = " << B[1] << '\n';
  cout << "B[2] = " << B[2] << '\n';
  cout << "B[3] = " << B[3] << '\n';
  cout << '\n' ;

  QR::applyReflections( 4, 4, A, 4, ipiv, work, B+4, 1 );
  cout << "B[4] = " << B[4] << '\n';
  cout << "B[5] = " << B[5] << '\n';
  cout << "B[6] = " << B[6] << '\n';
  cout << "B[7] = " << B[7] << '\n';
  cout << '\n' ;

  QR::applyReflections( 4, 4, A, 4, ipiv, work, B+8, 1 );
  cout << "B[8]  = " << B[8]  << '\n';
  cout << "B[9]  = " << B[9]  << '\n';
  cout << "B[10] = " << B[10] << '\n';
  cout << "B[11] = " << B[11] << '\n';
  cout << '\n' ;

  QR::applyReflections( 4, 4, A, 4, ipiv, work, B+12, 1 );
  cout << "B[12] = " << B[12] << '\n';
  cout << "B[13] = " << B[13] << '\n';
  cout << "B[14] = " << B[14] << '\n';
  cout << "B[15] = " << B[15] << '\n';
  cout << '\n' ;

  QR::solve( 4, A, 4, ipiv, work, b, 1 ) ;

  cout << "b[0] = " << b[0] << '\n';
  cout << "b[1] = " << b[1] << '\n';
  cout << "b[2] = " << b[2] << '\n';
  cout << "b[3] = " << b[3] << '\n';

  return 0 ;
}
